module exc(rst, clk, exc, rti, in_exc, exc_stage1, exc_stage2, exc_done, entering_exc);
   input  rst, clk;
   input  exc;		// exception instruction
   input  rti;		// RTI, for counting exception depth
   output in_exc;	// executing exception handler
   reg [3:0] exc_depth; // recursive exception depth, at most 15
   output exc_stage1;
   reg    exc_stage1;
   output exc_stage2;
   reg    exc_stage2;
   output exc_done;
   reg	  exc_done;
   output entering_exc;
   assign entering_exc = exc | exc_stage1 | exc_stage2;

   // exc: input signal (sync), push stack: PC = M[R6], R6--
   // exc_stage1: read exc addr: wd = M[0x44]
   // exc_done: PC <= wd
   always@(posedge clk or negedge rst)
     begin
       if (~rst)
         begin
         exc_stage1 <= 0;
	 exc_stage2 <= 0;
	 exc_done <= 0;
	 end
       else
	 begin
         exc_stage1 <= exc;
	 exc_stage2 <= exc_stage1;
	 exc_done <= exc_stage2;
	 end
     end

   assign in_exc = (exc_depth != 0);
   
   always@(posedge clk or negedge rst)
     begin
        if (~rst)
	  exc_depth <= 0;
	else if (exc)
	  exc_depth <= exc_depth + 1;
	else if (in_exc & rti)
	  exc_depth <= exc_depth - 1;
     end
endmodule // exc
