module memory(clk, addr, rd, wd, we, apsr);
   input clk;
   input [15:0] addr;
   output [15:0] rd;
   input [15:0] wd;
   input we;
   output [4:0] apsr;

   altsyncram ram(
			.wren_a(we),
			.data_a(wd),
			.address_a(addr),
			.clock0(clk),
			.q_a(rd)
			);
	defparam
		ram.operation_mode = "SINGLE_PORT",
		ram.width_a = 16,
		ram.widthad_a = 9,
		ram.lpm_hint = "ENABLE_RUNTIME_MOD=YES, INSTANCE_NAME=data_ram",
		ram.init_file = "inst_contains.mif";

   assign apsr[4:3] = 2'b00;
   assign apsr[2] = rd[15]; 			// negative
   assign apsr[1] = (rd == 16'b0);		// zero
   assign apsr[0] = ~rd[15] & ~apsr[1];	// positive

endmodule // memory
